--- old/usr/src/lib/pkcs11/pkcs11_softtoken/common/softBlowfishCrypt.c	Fri Jul  6 15:55:08 2018
+++ new/usr/src/lib/pkcs11/pkcs11_softtoken/common/softBlowfishCrypt.c	Fri Jul  6 15:55:08 2018
@@ -21,6 +21,7 @@
 /*
  * Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
+ * Copyright (c) 2018, Joyent, Inc.
  */
 
 #include <pthread.h>
@@ -297,15 +298,11 @@
 cleanup:
 	(void) pthread_mutex_lock(&session_p->session_mutex);
 	blowfish_ctx = (blowfish_ctx_t *)soft_blowfish_ctx->blowfish_cbc;
-	if (blowfish_ctx != NULL) {
-		bzero(blowfish_ctx->bc_keysched,
-		    blowfish_ctx->bc_keysched_len);
-		free(soft_blowfish_ctx->blowfish_cbc);
-	}
-
-	bzero(soft_blowfish_ctx->key_sched, soft_blowfish_ctx->keysched_len);
-	free(soft_blowfish_ctx->key_sched);
-	free(session_p->encrypt.context);
+	freezero(blowfish_ctx, sizeof (cbc_ctx_t));
+	freezero(soft_blowfish_ctx->key_sched,
+	    soft_blowfish_ctx->keysched_len);
+	freezero(session_p->encrypt.context,
+	    sizeof (soft_blowfish_ctx_t));
 	session_p->encrypt.context = NULL;
 	(void) pthread_mutex_unlock(&session_p->session_mutex);
 
@@ -465,15 +462,11 @@
 cleanup:
 	(void) pthread_mutex_lock(&session_p->session_mutex);
 	blowfish_ctx = (blowfish_ctx_t *)soft_blowfish_ctx->blowfish_cbc;
-	if (blowfish_ctx != NULL) {
-		bzero(blowfish_ctx->bc_keysched,
-		    blowfish_ctx->bc_keysched_len);
-		free(soft_blowfish_ctx->blowfish_cbc);
-	}
-
-	bzero(soft_blowfish_ctx->key_sched, soft_blowfish_ctx->keysched_len);
-	free(soft_blowfish_ctx->key_sched);
-	free(session_p->decrypt.context);
+	free(blowfish_ctx);
+	freezero(soft_blowfish_ctx->key_sched,
+	    soft_blowfish_ctx->keysched_len);
+	freezero(session_p->decrypt.context,
+	    sizeof (soft_blowfish_ctx_t));
 	session_p->decrypt.context = NULL;
 	(void) pthread_mutex_unlock(&session_p->session_mutex);
 
